grails-app/domain/gestionannonces/User.groovy
package gestionannonces

class User {

    String username
    String password
    Date dateCreated  // faut bien l'ecrire pour que grails les gerer automatiquement
    Date lastUpdated  // si non faut ecrire ce que tu veux et le gerer toi meme
    Illustration thumbnail

    static hasMany = [annonces:Annonce]

    static constraints = {
        username nullable: false,black:false,size: 5..20
        password password:true,nullable: false,black:false , size: 8..30
        thumbnail nullable: false
        annonces nullable: true
    }
}

grails-app/controllers/gestionannonces/UserController.groovy
package gestionannonces

import grails.validation.ValidationException
import org.springframework.web.multipart.MultipartHttpServletRequest

import static org.springframework.http.HttpStatus.*

class UserController {

    UserService userService

    static allowedMethods = [save: "POST", update: "PUT", delete: "DELETE"]

    def index(Integer max) {
        params.max = Math.min(max ?: 10, 100)
        respond userService.list(params), model:[userCount: userService.count()]
    }

    def show(Long id) {
        respond userService.get(id)
    }


    def create() {
        respond new User(params)
    }

    def save(User user) {
        if (user == null) {
            notFound()
            return
        }

        try {

//            definir la méthode si c'est creation ou edition
            def methode = params.methode

            def x = request.getFile('fileUpload')  // x est le fichier inserer en upload

            if (x == null || x.empty){
                if (methode == "creation"){
                    // ajout d'une image par defaut en cas de non saisie d'image à l'ajout au modification pas de blem
                    user.thumbnail = new Illustration(filename: grailsApplication.config.maConfig.avatar_default)
                }
            }else{

                def pool = ['a'..'z','A'..'Z',0..9,'_'].flatten()
                Random rand = new Random(System.currentTimeMillis())
                def randomTab = (0..10).collect { pool[rand.nextInt(pool.size())] }

                def randomString =""
                for (item in randomTab) {
                    randomString = randomString + item
                }

                randomString =  randomString + ".png"

                def File = new File (grailsApplication.config.maConfig.assets_url + randomString) // file de copy

                if (File.exists()){
                    flash.message = "Fichier déjà existant"
                    return
                }else{
                    x.transferTo(File)
                    user.thumbnail = new Illustration(filename: randomString)  // si c'est de nombreux avatar faux faire user.addtouser
                }
            }

            userService.save(user)


        } catch (ValidationException e) {
            respond user.errors, view:'create'
            return
        }

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.created.message', args: [message(code: 'user.label', default: 'User'), user.id])
                redirect user
            }
            '*' { respond user, [status: CREATED] }
        }
    }

    def edit(Long id) {
        respond userService.get(id)
    }

    def update(User user) {
        if (user == null) {
            notFound()
            return
        }

        try {
            userService.save(user)
        } catch (ValidationException e) {
            respond user.errors, view:'edit'
            return
        }

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.updated.message', args: [message(code: 'user.label', default: 'User'), user.id])
                redirect user
            }
            '*'{ respond user, [status: OK] }
        }
    }

    def delete(Long id) {
        if (id == null) {
            notFound()
            return
        }

        userService.delete(id)

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.deleted.message', args: [message(code: 'user.label', default: 'User'), id])
                redirect action:"index", method:"GET"
            }
            '*'{ render status: NO_CONTENT }
        }
    }

    protected void notFound() {
        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.not.found.message', args: [message(code: 'user.label', default: 'User'), params.id])
                redirect action: "index", method: "GET"
            }
            '*'{ render status: NOT_FOUND }
        }
    }

}

grails-app/views/user/create.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main"/>
    <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}"/>
    <title><g:message code="default.create.label" args="[entityName]"/></title>
</head>

<body>
<a href="#create-user" class="skip" tabindex="-1"><g:message code="default.link.skip.label"
                                                             default="Skip to content&hellip;"/></a>

<div class="nav" role="navigation">
    <ul>
        <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
        <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]"/></g:link></li>
    </ul>
</div>

<div id="create-user" class="content scaffold-create" role="main">
    <h1><g:message code="default.create.label" args="[entityName]"/></h1>
    <g:if test="${flash.message}">
        <div class="message" role="status">${flash.message}</div>
    </g:if>
    <g:hasErrors bean="${this.user}">
        <ul class="errors" role="alert">
            <g:eachError bean="${this.user}" var="error">
                <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message
                        error="${error}"/></li>
            </g:eachError>
        </ul>
    </g:hasErrors>

    <form action="save" method="POST" enctype='multipart/form-data' >
        <input type="hidden" name="methode" value="creation"/>
        <fieldset class="form">
            <div class='fieldcontain required'>
                <label for='username'>Username
                    <span class='required-indicator'>*</span>
                </label>
                <input type="text" name="username" value="" required="" maxlength="20" id="username" />

            </div>

            <div class='fieldcontain required'>
                <label for='password'>Password
                    <span class='required-indicator'>*</span>
                </label>
                <input type="password" name="password" required="" maxlength="30" value="" id="password" />

            </div>

            <div class='fieldcontain required'>
                <label for='thumbnail'>Thumbnail
                    <span class='required-indicator'>*</span>
                </label>
                <input type="file" name="fileUpload" id="thumbnail" accept="image/png" />
            </div>
        </fieldset>



        <fieldset class="buttons">
            <g:submitButton name="create" class="save"
                            value="${message(code: 'default.button.create.label', default: 'Create')}"/>
        </fieldset>
    </form>

</div>
</body>
</html>

grails-app/views/user/edit.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main" />
    <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}" />
    <title><g:message code="default.edit.label" args="[entityName]" /></title>
</head>
<body>
<a href="#edit-user" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
<div class="nav" role="navigation">
    <ul>
        <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
        <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
        <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
    </ul>
</div>
<div id="edit-user" class="content scaffold-edit" role="main">
    <h1><g:message code="default.edit.label" args="[entityName]" /></h1>
    <g:if test="${flash.message}">
        <div class="message" role="status">${flash.message}</div>
    </g:if>
    <g:hasErrors bean="${this.user}">
        <ul class="errors" role="alert">
            <g:eachError bean="${this.user}" var="error">
                <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
            </g:eachError>
        </ul>
    </g:hasErrors>
    <g:form resource="${this.user}" method="POST" enctype='multipart/form-data' >

%{--        pour connaitre l'ecran edition ou creation--}%
        <g:hiddenField name="methode" value="edition" />


        <g:hiddenField name="version" value="${this.user?.version}" />
    %{--                <fieldset class="form">--}%
    %{--                    <f:all bean="user"/>--}%
    %{--                </fieldset>--}%

        <f:field bean="user" property="username"/>
        <f:field bean="user" property="thumbnail">
            <g:img width="100" file="${user.thumbnail.filename}" />
        </f:field>

        <f:field bean="user" property="annonces">
            <div class="property-value" aria-labelledby="annonces-label">
                <ul>
                    <g:each in="${user.annonces}" var="ann">
                        <li><g:link controller="annonce" action="show" id="${ann.id}">${ann.title}</g:link></li>
                    </g:each>
                </ul>
            </div>
        </f:field>

        <div class='fieldcontain required'>
            <label for='thumbnail'>Thumbnail Update
            </label>
            <input type="file" name="fileUpload" id="thumbnail" accept="image/png" />
        </div>
        <br>


        <fieldset class="buttons">
            <input class="save" type="submit" value="${message(code: 'default.button.update.label', default: 'Update')}" />
        </fieldset>

    </g:form>
</div>
</body>
</html>

grails-app/views/user/index.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main"/>
    <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}"/>
    <title><g:message code="default.list.label" args="[entityName]"/></title>
</head>

<body>
<a href="#list-user" class="skip" tabindex="-1"><g:message code="default.link.skip.label"
                                                           default="Skip to content&hellip;"/></a>

<div class="nav" role="navigation">
    <ul>
        <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
        <li><g:link class="create" action="create"><g:message code="default.new.label"
                                                              args="[entityName]"/></g:link></li>
    </ul>
</div>

<div id="list-user" class="content scaffold-list" role="main">
    <h1><g:message code="default.list.label" args="[entityName]"/></h1>
    <g:if test="${flash.message}">
        <div class="message" role="status">${flash.message}</div>
    </g:if>

%{--    <f:table collection="${userList}"/>
    modification des données de la table
--}%



    <table>
        <thead>
        <tr>
            <th class="sortable"><a href="/user/index?sort=username&amp;max=10;order=asc">Nom utilisateur</a></th>
            <th class="sortable">Avatar</th>
            <th class="sortable">Annonces</th>
        </tr>
        </thead>
        <tbody>
        <g:each in="${userList}" var="instance" status="i">

        %{--            condition pour definir la class--}%

            <tr class="${(i % 2) == 0 ? 'even' : 'odd'}">
                <td><g:link controller="user" action="show" id="${instance.id}">${instance.username}</g:link></td>
                <td>
                    <g:link controller="illustration" action="show" id="${instance.thumbnail.id}">
                        <g:img width="50" file="${instance.thumbnail.filename}"/>
                    </g:link>
                </td>
                <td>
                    <ul>
                        <g:each in="${instance.annonces}" var="ann">
                            <li><g:link controller="annonce" action="show" id="${ann.id}">${ann.title}</g:link></li>
                        </g:each>
                    </ul>
                </td>
            </tr>
        </g:each>
        </tbody>
    </table>


    <div class="pagination">
        <g:paginate total="${userCount ?: 0}"/>
    </div>
</div>
</body>
</html>

grails-app/views/user/show.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main" />
    <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}" />
    <title><g:message code="default.show.label" args="[entityName]" /></title>
</head>
<body>
<a href="#show-user" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
<div class="nav" role="navigation">
    <ul>
        <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
        <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
        <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
    </ul>
</div>
<div id="show-user" class="content scaffold-show" role="main">
    <h1><g:message code="default.show.label" args="[entityName]" /></h1>
    <g:if test="${flash.message}">
        <div class="message" role="status">${flash.message}</div>
    </g:if>

%{--    <f:display bean="user" />--}%

    <ol class="property-list user">

        <li class="fieldcontain">
            <span id="username-label" class="property-label">Nom d'utilisateur</span>
            <div class="property-value" aria-labelledby="username-label">${user.username}</div>
        </li>

        <li class="fieldcontain">
            <span id="thumbnail-label" class="property-label">Thumbnail</span>
            <div class="property-value" aria-labelledby="thumbnail-label">
                <g:link controller="illustration" action="show" id="${user.thumbnail.id}">
                    <g:img width="100" file="${user.thumbnail.filename}"/>
                </g:link>
            </div>
        </li>

        <li class="fieldcontain">
            <span id="annonces-label" class="property-label">Annonces</span>
            <div class="property-value" aria-labelledby="annonces-label">
                <ul>
                    <g:each in="${user.annonces}" var="ann">
                        <li><g:link controller="annonce" action="show" id="${ann.id}">${ann.title}</g:link></li>
                    </g:each>
                </ul>
            </div>
        </li>

    </ol>


    <g:form resource="${this.user}" method="DELETE">
        <fieldset class="buttons">
            <g:link class="edit" action="edit" resource="${this.user}"><g:message code="default.button.edit.label" default="Edit" /></g:link>
            <input class="delete" type="submit" value="${message(code: 'default.button.delete.label', default: 'Delete')}" onclick="return confirm('${message(code: 'default.button.delete.confirm.message', default: 'Are you sure?')}');" />
        </fieldset>
    </g:form>

</div>
</body>
</html>